/*
 * DrawProg.java
 *
 * Created on 23 de Maio de 2000, 11:09
 */
 


/** 
 *
 * @author  agomes
 * @version 
 */

import javax.swing.plaf.metal.*;
import java.awt.Dimension;
import java.awt.Color;

public class DrawProg extends javax.swing.JFrame {

  static final int LINETOOL = 0;
  static final int RECTTOOL = 1;
  static final int POLYTOOL = 2;

  private AnyTool toolSelected;
  private AnyTool[] tools = new AnyTool[3];

  DrawArea drawArea;
  
  /** Creates new form DrawProg */
  public DrawProg() {
    initComponents ();
    
    //Set up the GUI.
    drawArea = createDrawArea();
    desktopPane.add(drawArea);
    desktopPane.setPreferredSize(new Dimension(drawArea.getWidth() + 2 * drawArea.getMargin(), drawArea.getHeight() + 2 * drawArea.getMargin()));
    
    tools[LINETOOL] = new LineTool();
    tools[RECTTOOL] = new RectTool();
    tools[POLYTOOL] = new PolyTool();

    toolSelected = tools[LINETOOL];
    toolSelected.startTool();

    pack ();
  }
  
  private DrawArea createDrawArea()
  {
    DrawArea dArea = new DrawArea(this);
    dArea.setVisible(true); //necessary as of kestrel

    try {
      dArea.setSelected(true);
    } catch (Exception e) { };
    
    return(dArea);
  }

  public void setXY(String s)
  {
    this.editXY.setText(s);
  }
	
  public void changeTool(int newTool)
  {
    toolSelected.stopTool();
    toolSelected = tools[newTool];
    toolSelected.startTool();
  }
	
  public AnyTool getToolSelected()
  {
    return(toolSelected);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    desktopPane = new javax.swing.JDesktopPane ();
    panelTools = new javax.swing.JPanel ();
    xyPanel = new javax.swing.JPanel ();
    labelXY = new javax.swing.JLabel ();
    editXY = new javax.swing.JLabel ();
    buttonLine = new javax.swing.JButton ();
    buttonRect = new javax.swing.JButton ();
    buttonPoly = new javax.swing.JButton ();
    setTitle ("Draw Program");
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );



    getContentPane ().add (desktopPane, java.awt.BorderLayout.CENTER);

    panelTools.setLayout (new java.awt.GridBagLayout ());
    java.awt.GridBagConstraints gridBagConstraints1;

  
        labelXY.setText ("XY: ");
    
        xyPanel.add (labelXY);
    
        editXY.setPreferredSize (new java.awt.Dimension(55, 20));
        editXY.setMaximumSize (new java.awt.Dimension(55, 20));
        editXY.setOpaque (true);
        editXY.setBackground (java.awt.Color.white);
        editXY.setBorder (new javax.swing.border.BevelBorder(1));
        editXY.setMinimumSize (new java.awt.Dimension(55, 20));
        editXY.setText (" 0, 0");
    
        xyPanel.add (editXY);
    
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      panelTools.add (xyPanel, gridBagConstraints1);
  
      buttonLine.setPreferredSize (new java.awt.Dimension(60, 27));
      buttonLine.setMaximumSize (new java.awt.Dimension(60, 27));
      buttonLine.setMinimumSize (new java.awt.Dimension(60, 27));
      buttonLine.setText ("Line");
      buttonLine.addMouseListener (new java.awt.event.MouseAdapter () {
        public void mousePressed (java.awt.event.MouseEvent evt) {
          buttonLineMousePressed (evt);
        }
      }
      );
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 1;
      panelTools.add (buttonLine, gridBagConstraints1);
  
      buttonRect.setPreferredSize (new java.awt.Dimension(60, 27));
      buttonRect.setMaximumSize (new java.awt.Dimension(60, 27));
      buttonRect.setMinimumSize (new java.awt.Dimension(60, 27));
      buttonRect.setText ("Rect");
      buttonRect.addMouseListener (new java.awt.event.MouseAdapter () {
        public void mousePressed (java.awt.event.MouseEvent evt) {
          buttonRectMousePressed (evt);
        }
      }
      );
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 2;
      panelTools.add (buttonRect, gridBagConstraints1);
  
      buttonPoly.setPreferredSize (new java.awt.Dimension(60, 27));
      buttonPoly.setMaximumSize (new java.awt.Dimension(60, 27));
      buttonPoly.setMinimumSize (new java.awt.Dimension(60, 27));
      buttonPoly.setText ("Poly");
      buttonPoly.addMouseListener (new java.awt.event.MouseAdapter () {
        public void mousePressed (java.awt.event.MouseEvent evt) {
          buttonPolyMousePressed (evt);
        }
      }
      );
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 3;
      panelTools.add (buttonPoly, gridBagConstraints1);
  

    getContentPane ().add (panelTools, java.awt.BorderLayout.WEST);

  }//GEN-END:initComponents

  private void buttonPolyMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonPolyMousePressed
// Add your handling code here:
    changeTool(POLYTOOL);
  }//GEN-LAST:event_buttonPolyMousePressed

  private void buttonRectMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonRectMousePressed
// Add your handling code here:
    changeTool(RECTTOOL);
  }//GEN-LAST:event_buttonRectMousePressed

  private void buttonLineMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonLineMousePressed
// Add your handling code here:
    changeTool(LINETOOL);
  }//GEN-LAST:event_buttonLineMousePressed

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm

  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
    new DrawProg ().show ();
  }


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JDesktopPane desktopPane;
  private javax.swing.JPanel panelTools;
  private javax.swing.JPanel xyPanel;
  private javax.swing.JLabel labelXY;
  private javax.swing.JLabel editXY;
  private javax.swing.JButton buttonLine;
  private javax.swing.JButton buttonRect;
  private javax.swing.JButton buttonPoly;
  // End of variables declaration//GEN-END:variables

}