/*
 * PolyTool.java
 *
 * Created on 15 de Maio de 2000, 16:32
 */
 
/** 
 *
 * @author  agomes
 * @version 
 */

import java.awt.event.MouseEvent;
import java.awt.Color;
import java.awt.Graphics;

public class PolyTool implements AnyTool 
{
  int x0, y0, x1, y1;
  boolean drawing;

  /** Creates new LineTool */
  public PolyTool()
  {
    x0 = y0 = x1 = y1 = 0;
    drawing = false;
  }

  public void startTool()
  {
    drawing = false;
  }

  public void stopTool()
  {
    if(drawing)
    {
      breakPoly();
      drawing = false;
    }
  }

  public void mousePressed(Graphics g,java.awt.event.MouseEvent evt)
  {
    if(drawing)
      polyPoint(g, evt.getX(), evt.getY());
    else if( evt.getClickCount() == 1 )
    {
      beginPoly(g, evt.getX(), evt.getY());
      drawing = true;
    }
  }

  public void mouseMoved(Graphics g,java.awt.event.MouseEvent evt)
  {
    if(drawing)
      rubberP1Poly(g, evt.getX(), evt.getY());
  }

  public void mouseReleased(Graphics g,java.awt.event.MouseEvent evt)
  {
  }

  public void mouseDoubleClicked(Graphics g,java.awt.event.MouseEvent evt)
  {
    if(drawing)
    {
      endPoly(g);
      drawing = false;
    }
  }

  public void mouseDragged(Graphics g,java.awt.event.MouseEvent evt)
  {
      rubberP1Poly(g, evt.getX(), evt.getY());
  }

  public void mouseClicked(Graphics g,java.awt.event.MouseEvent evt)
  {
  }

  private void beginPoly(Graphics g, int x, int y)
  {
    x0 = x; y0 = y;
    x1 = x; y1 = y;
    g.setColor(Color.black);
    g.setPaintMode();
    g.drawLine(x0, y0, x1, y1);
  }

  private void rubberP1Poly(Graphics g, int x, int y)
  {
    g.setColor(Color.white);
    g.setXORMode(Color.black);
    g.drawLine(x0, y0, x1, y1);
    x1 = x; y1 = y;
    g.drawLine(x0, y0, x1, y1);
  }

  private void endPoly(Graphics g)
  {
    g.setColor(Color.black);
    g.setPaintMode();
    g.drawLine(x0, y0, x1, y1);
  }

  private void breakPoly()
  {
//    g.drawLine(x0, y0, x1, y1);
  }

  private void polyPoint(Graphics g, int x, int y)
  {
    g.drawLine(x0, y0, x1, y1);
    x0 = x; y0 = y;
    x1 = x; y1 = y;
  }
}
