/*
 * RectTool.java
 *
 * Created on 15 de Maio de 2000, 16:32
 */
 
/** 
 *
 * @author  agomes
 * @version 
 */

import java.awt.event.MouseEvent;
import java.awt.Color;
import java.awt.Graphics;

public class RectTool implements AnyTool 
{
  int x0, y0, x1, y1, w, h;

  /** Creates new RectTool */
  public RectTool()
  {
    x0 = y0 = x1 = y1 = w = h = 0;
  }

  public void startTool()
  {
  }

  public void stopTool()
  {
  }

  public void mousePressed(Graphics g,java.awt.event.MouseEvent evt)
  {
      beginRect(g, evt.getX(), evt.getY());
  }

  public void mouseMoved(Graphics g,java.awt.event.MouseEvent evt)
  {
  }

  public void mouseReleased(Graphics g,java.awt.event.MouseEvent evt)
  {
      endRect(g, evt.getX(), evt.getY());
  }

  public void mouseDoubleClicked(Graphics g,java.awt.event.MouseEvent evt)
  {
  }

  public void mouseDragged(Graphics g,java.awt.event.MouseEvent evt)
  {
      rubberP1Rect(g, evt.getX(), evt.getY());
  }

  public void mouseClicked(Graphics g,java.awt.event.MouseEvent evt)
  {
  }

  private void beginRect(Graphics g, int x, int y)
  {
    x0 = x; y0 = y;
    x1 = x; y1 = y;
    w = 0; h = 0;
    g.setColor(Color.black);
    g.setPaintMode();
    g.drawRect(x1, y1, w, h);
  }

  private void rubberP1Rect(Graphics g, int x, int y)
  {
    g.setColor(Color.white);
    g.setXORMode(Color.black);
    g.drawRect(x1, y1, w, h);
    w = x-x0; h = y-y0;
    if(w < 0) { w = -w; x1 = x; } else x1 = x0;
    if(h < 0) { h = -h; y1 = y; } else y1 = y0;
    g.drawRect(x1, y1, w, h);
  }

  private void endRect(Graphics g, int x, int y)
  {
    g.setColor(Color.black);
    g.setPaintMode();
    g.drawRect(x1, y1, w, h);
  }
}
