/*
 * XORCanvas.java
 *
 * Created on 22 de Maio de 2000, 15:03
 */
 


/** 
 *
 * @author  agomes
 * @version 
 */

import java.awt.Graphics;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.event.MouseEvent;
import javax.swing.SwingUtilities;

public class XORCanvas extends Canvas {

  String paintRequest;
  MouseEvent mouseEvent;
  DrawArea drawArea;
  
  /** Creates new XORCanvas */
  public XORCanvas(DrawArea d) {
    drawArea = d;
    setBackground(Color.white);
    paintRequest = null;
    
    addMouseListener(new java.awt.event.MouseAdapter () {
        public void mousePressed (java.awt.event.MouseEvent evt) {
          xorCanvasMousePressed (evt);
        }
        public void mouseReleased (java.awt.event.MouseEvent evt) {
          xorCanvasMouseReleased (evt);
        }
        public void mouseClicked (java.awt.event.MouseEvent evt) {
          xorCanvasMouseClicked (evt);
        }
      }
      );

    addMouseMotionListener(new java.awt.event.MouseMotionAdapter () {
        public void mouseMoved (java.awt.event.MouseEvent evt) {
          xorCanvasMouseMoved (evt);
        }
        public void mouseDragged (java.awt.event.MouseEvent evt) {
          xorCanvasMouseDragged (evt);
        }
      }
      );
  }
  
  private void xorCanvasMousePressed(java.awt.event.MouseEvent evt) {
// Add your handling code here:
    if( SwingUtilities.isLeftMouseButton(evt))
    {
      mouseEvent = evt;
      paintRequest = "MousePressed";
      repaint();
    }
  }
  
  private void xorCanvasMouseReleased(java.awt.event.MouseEvent evt) {
// Add your handling code here:
    if( SwingUtilities.isLeftMouseButton(evt))
    {
      mouseEvent = evt;
      paintRequest = "MouseReleased";
      repaint();
    }
  }
  
  private void xorCanvasMouseClicked(java.awt.event.MouseEvent evt) {
// Add your handling code here:
    if( SwingUtilities.isLeftMouseButton(evt))
    {
      mouseEvent = evt;
      if(evt.getClickCount() == 1 )
        paintRequest = "MouseClicked";
      else if(evt.getClickCount() == 2 )
        paintRequest = "MouseDoubleClicked";
      repaint();
    }
  }
  
  private void xorCanvasMouseMoved(java.awt.event.MouseEvent evt) {
// Add your handling code here:
    drawArea.drawProg.setXY(evt.getX() + ", " + evt.getY());
    mouseEvent = evt;
    paintRequest = "MouseMoved";
    repaint();
  }
  
  private void xorCanvasMouseDragged(java.awt.event.MouseEvent evt) {
// Add your handling code here:
    drawArea.drawProg.setXY(evt.getX() + ", " + evt.getY());
    if( SwingUtilities.isLeftMouseButton(evt))
    {
      mouseEvent = evt;
      paintRequest = "MouseDragged";
      repaint();
    }
  }
  
  public void update(Graphics g)
  {
    paint(g);
  }
  
  public void paint(Graphics g)
  {
    if(paintRequest == "MousePressed")
      drawArea.drawProg.getToolSelected().mousePressed(g, mouseEvent);
    else if(paintRequest == "MouseReleased")
      drawArea.drawProg.getToolSelected().mouseReleased(g, mouseEvent);
    else if(paintRequest == "MouseClicked")
      drawArea.drawProg.getToolSelected().mouseClicked(g, mouseEvent);
    else if(paintRequest == "MouseDoubleClicked")
      drawArea.drawProg.getToolSelected().mouseDoubleClicked(g, mouseEvent);
    else if(paintRequest == "MouseMoved")
      drawArea.drawProg.getToolSelected().mouseMoved(g, mouseEvent);
    else if(paintRequest == "MouseDragged")
      drawArea.drawProg.getToolSelected().mouseDragged(g, mouseEvent);
    
    paintRequest = null;
  }
}